<?php
// namespace Pelecardwc\CheckoutIframe;

require 'GetCurrency.php';
require 'RequestIframe.php';



function get_checkout_iframe_url( WC_Order $order, $gateway ) {
	$args = apply_filters( 'wppc/checkout/iframe_args', [
		'terminal' => $gateway->wppc_terminal(),
		'user' => $gateway->wppc_username(),
		'password' => $gateway->wppc_password(),
		'GoodURL' => $gateway->get_return_url( $order ),
		'ErrorURL' => $gateway->get_return_url( $order ),
		'CancelURL' => 'yes' === $gateway->get_option( 'cancel_button' ) ? $order->get_cancel_order_url() : '',
		'ActionType' => $gateway->wppc_get_action_type(),
		'Currency' => get_currency( $order ),
		'Total' => $order->get_total() * 100,
		'FreeTotal' => 'yes' === $gateway->get_option( 'free_total' ),
		'ServerSideGoodFeedbackURL' => 'wc-pelecard',
		'ServerSideErrorFeedbackURL' => 'wc-pelecard',
		'CreateToken' => true,
		'Language' => $gateway->get_option( 'language' ),
		'CardHolderName' => $gateway->get_option( 'card_holder_name' ),
		'CustomerIdField' => $gateway->get_option( 'customer_id_field' ),
		'Cvv2Field' => $gateway->get_option( 'cvv2_field' ),
		'EmailField' => 'value' === $gateway->get_option( 'email_field' ) ? $order->get_billing_email() : $gateway->get_option( 'email_field' ),
		'TelField' => 'value' === $gateway->get_option( 'tel_field' ) ? $order->get_billing_phone() : $gateway->get_option( 'tel_field' ),
		'SplitCCNumber' => 'yes' === $gateway->get_option( 'split_cc_number' ),
		'FeedbackOnTop' => true,
		'FeedbackDataTransferMethod' => 'POST',
		'MaxPayments' => $gateway->wppc_maximum_payments(),
		'MinPayments' => $gateway->wppc_minimum_payments(),
		'MinPaymentsForCredit' => $gateway->get_option( 'min_credit' ),
		'FirstPayment' => $gateway->get_option( 'first_payment' ),
		'ParamX' => $order->get_id(),
		'UserKey' => $order->get_order_key(),
		'SetFocus' => $gateway->get_option( 'set_focus' ),
		'CssURL' => $gateway->get_option( 'css_url' ),
		'TopText' => $gateway->get_option( 'top_text' ),
		'BottomText' => $gateway->get_option( 'bottom_text' ),
		'LogoURL' => $gateway->get_option( 'logo_url' ),
		'ShowConfirmationCheckbox' => $gateway->get_option( 'confirmation_cb' ),
		'TextOnConfirmationBox' => $gateway->get_option( 'confirmation_text' ),
		'ConfirmationLink' => $gateway->get_option( 'confirmation_url' ),
		'HiddenPelecardLogo' => 'no' === $gateway->get_option( 'hidden_pelecard_logo' ),
		'SupportedCards' => $gateway->wppc_supported_cards(),
		'UserData' => [
			'UserData1' => $order->get_user_id(),
			'UserData2' => $gateway->get_timeout_url( $order ),
		],
	], $order, $gateway );

	return request_iframe_url( $args );
}
?>